/*
								+---------------------------------+
								|                                 |
								|   ***   Segment_Manager   ***   |
								|                                 |
								|    Copyright  L. Polok  2002   |
								|                                 |
								|            Seg_Man.h            |
								|                                 |
								+---------------------------------+
*/

enum {
    Mem_Insufficient = -1,
    Mem_OK = 0
};

struct Segment {
	struct Segment *prev, *next;
	//
	float z1, u1, v1;
	float dudx, dvdx, dzdx;
	int x1, x2;
	//
	Texture *texture;
	int mip_level;
};

struct Scanline {
	Segment *segm;
	Segment *last;
	int n_seg_used;
	int n_seg_num;
};

Segment *GetSegmentBehind(Scanline *sl, Segment *cur, Segment *seg);
int				InitSManager();
void			UninitSManager();
void			ResetSManager();
int             InitScanline(int seg_n, Scanline *sl);
void _fastcall	AddSegment(Segment *seg, Scanline *sc);
int				GetMem_Status();
int				GetMem_Usage();
int _fastcall   Segment_Visibility(Segment *seg, Scanline *sc);
int _fastcall   Segment_Visible(Segment *seg, Scanline *sc);